package ledky;

import java.net.URL;
import java.util.ResourceBundle;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.CheckBox;
import javafx.scene.control.ComboBox;
import javafx.scene.control.Label;
import javafx.scene.input.MouseEvent;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;

/**
 *
 * @author lsroubov
 */
public class FXMLDocumentController implements Initializable {
    private final Color barvaVstupLEDsvitici = Color.BLUE;
    private final Color barvaVstupLEDzhasnuta = Color.DARKGREY;
    private final Color barvaVystupLEDzhasnuta = Color.DARKGREY;
    private final Color barvaVystupLEDsvitici = Color.RED;
    
    private boolean stateLedA = false;
    private boolean stateLedB = false;
    private boolean stateLedC = false;
    
    @FXML
    private Label label;
    
    @FXML
    private void handleButtonAction(ActionEvent event) {
        System.out.println("Klikni!");
        label.setText("Vitej. Klikej na ledky vlevo, vyber operaci, a sleduj!");
    }
    
    @FXML
    Circle ledA;

    @FXML
    Circle ledB;

    @FXML
    Circle ledC;

    @FXML
    ComboBox<String> menu;

    @FXML
    CheckBox notChkBox;
    
    private void updateResultLEDstate() {
        switch (menu.getValue()) {
            case "AND":
                stateLedC = stateLedA && stateLedB;
                break;
            case "OR":
                stateLedC = stateLedA || stateLedB;
                break;
            case "XOR":
                stateLedC = stateLedA ^ stateLedB;
                break;
        }
        // negace výstupu, pokud je vybrán check box NOT
        if (notChkBox.isSelected()) {
            stateLedC = !stateLedC;
        }
    }

    private void updateLEDsColors() {
        if (stateLedA) {
            ledA.setFill(barvaVstupLEDsvitici);
        } else {
            ledA.setFill(barvaVstupLEDzhasnuta);
        }
        if (stateLedB) {
            ledB.setFill(barvaVstupLEDsvitici);
        } else {
            ledB.setFill(barvaVstupLEDzhasnuta);
        }
        if (stateLedC) {
            ledC.setFill(barvaVystupLEDsvitici);
        } else {
            ledC.setFill(barvaVystupLEDzhasnuta);
        }
    }

    @FXML
    private void handleSwitchLEDstate(MouseEvent event) {
        if (event.getSource().equals(ledA)) {
            stateLedA = !stateLedA;
        }
        if (event.getSource().equals(ledB)) {
            stateLedB = !stateLedB;
        }
        updateResultLEDstate();
        updateLEDsColors();
    }

    @FXML
    private void handleLogicalOperationChange(ActionEvent event) {
        updateResultLEDstate();
        updateLEDsColors();
    }

    @Override
    public void initialize(URL url, ResourceBundle rb) {
        menu.getItems().addAll("AND", "OR", "XOR");
        menu.setValue("AND");
        updateResultLEDstate();
        updateLEDsColors();
    }    
    
}
